package org.jboss.soa.esb.samples.quickstart.juddi;

public class Utils {

	public static Class<?> forName(String name, Class<?> caller) throws ClassNotFoundException {
		ClassLoader threadClassLoader = Thread.currentThread().getContextClassLoader();
		if(threadClassLoader != null) {
			try {
				return Class.forName(name, true, threadClassLoader);
			} catch (ClassNotFoundException e) {
				if(e.getException() != null) {
					throw e;
				}
			}
		}
		
		ClassLoader callerClassLoader = caller.getClassLoader();
		if(callerClassLoader != null) {
			try {
				return Class.forName(name, true, callerClassLoader);
			} catch (ClassNotFoundException e) {
				if(e.getException() != null) {
					throw e;
				}
			}
		}
		
		return Class.forName(name, true, ClassLoader.getSystemClassLoader());
		
	}
	
}
