package org.jboss.soa.esb.samples.quickstart.juddi.tck;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.JAXBElement;

import org.apache.juddi.jaxb.EntityCreator;

import org.uddi.api_v3.BusinessService;

public class TckResourceLoader {

	public static final String JUDDI_PACKAGE = "org.uddi.api_v3";

	public static Map<String, BusinessService> copyBusinessServices(String serviceXML, String serviceKey, int numberOfCopies)
		throws Exception
	{
		try {
			Map<String, BusinessService> copies = new HashMap<String, BusinessService>();
			String serviceAsXmlText = loadFileContent(serviceXML);
			for (int i=0; i<numberOfCopies; i++) {
				JAXBElement<?> element = (JAXBElement<?>) EntityCreator.buildFromString(serviceAsXmlText, JUDDI_PACKAGE);
				BusinessService bs = (BusinessService) element.getValue();
				String serviceName = bs.getName().get(0).getValue();
				String bindingKey = bs.getBindingTemplates().getBindingTemplate().get(0).getBindingKey();
				bs.getName().get(0).setValue(serviceName + "-" + i);
				bs.setServiceKey(serviceKey + "-" + i);
				bs.getBindingTemplates().getBindingTemplate().get(0).setBindingKey(bindingKey + "-" + i);
				copies.put(bs.getServiceKey(), bs);
			}
			
			return copies;
		} catch (Exception e) {
			System.out.println("#### Exception: " + e);
			throw e;
		}
	}
	
	public static String loadFileContent(String fileName) throws Exception {
		try {
			StringBuffer contentBuffer = new StringBuffer();
			URL url = Thread.currentThread().getContextClassLoader().getResource(fileName);
			if(url == null) {
			    System.out.println("Resource '" + fileName + "' not found!");
			}
			
			BufferedReader in = new BufferedReader(new InputStreamReader(url.openStream()));
			String line = null;
			while((line = in.readLine()) != null) {
				contentBuffer.append(line + "\n");
			}
			return contentBuffer.toString();
		} catch (Exception e) {
			System.out.println("#### Exception: " + e);
			throw e;
		}
	}
}
